#TEMPLATE(dcTranslate,'DinamiComp Translation Templates'),FAMILY('ABC')
#!--------------------------------------------------------------------------
#!
#! All Rights Reserved World Wide
#! 
#!
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!                                               APPLICATION EXTENSION
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!
#EXTENSION(dcTranslateGlobal,'DinamiComp''s Translation-Global'),APPLICATION(TranslatorClass)
#!
#SHEET
#! Custom for this template
#!------------------------------------------------------------------------------------------------------------------------
#TAB('General')
    #INSERT  (%SETCC)
    #INSERT  (%SETAPP)
    #DISPLAY ('')
    #BOXED('Single Exe App'),Section,Where(%ProgramExtension <> 'DLL'),Hide,AT(,50,,20)
        #PROMPT  ('This is Single Exe Appp',Check),%dcSingleExe,AT(10)
    #ENDBOXED    
    #BOXED   ('Debugging'),Section,AT(,70,,30)
       #PROMPT  ('Disable DinamiComp''s Translation Templates',Check),%dcDisableTranslate,AT(10)
       #PROMPT  ('Disable All DinamiComp Templates',Check),%dcDisableAll,AT(10)
    #ENDBOXED
#ENDTAB
#TAB('Database Tables'), WHERE((%ProgramExtension = 'DLL' AND %GlobalExternal = %FALSE and %dcDisableTranslate = %False) or (%dcSingleExe = %TRUE and %dcDisableTranslate = %False))
    #DISPLAY ('')
    #DISPLAY ('You should have a TPS/SQL file containing Search &&')
    #DISPLAY ('Replace Strings')
    #DISPLAY ('')
    #BOXED('Translation Table'),Section
       #DISPLAY ('')
       #PROMPT  ('Use Set, Send and Next for SQL Files?',CHECK),%dcUseSQLFiles,AT(10)
       #DISPLAY ('')
       #PROMPT  ('Translate-File',FILE),%dcTranslateFile,REQ
       #PROMPT  ('Translate-Language Key',Key(%dcTranslateFile)),%dcTranslateKey,REQ
       #PROMPT  ('Translate-Language SysId',Field(%dcTranslateFile)),%dcSysIdTranslate,REQ
       #PROMPT  ('Translate-Search String',Field(%dcTranslateFile)),%dcSearchString,REQ
       #PROMPT  ('Translate-Replace String',Field(%dcTranslateFile)),%dcReplaceString,REQ
    #ENDBOXED
    #DISPLAY ('')
    #PROMPT  ('Use Language File',CHECK),%dcUseLanguageFile,AT(10)
    #DISPLAY ('')
    #ENABLE(%dcUseLanguageFile=%TRUE)
       #BOXED   ('Language Settings'),Section
          #DISPLAY ('')
          #DISPLAY ('This Template uses a Default Language System Id to')
          #DISPLAY ('determine which language file will be used for runtime')
          #DISPLAY ('translation. The Default Language System Id must be')
          #DISPLAY ('saved in an Ini File. This Process will also load a')
          #DISPLAY ('specific Language environment file (.ENV)')
          #DISPLAY ('')
          #PROMPT  ('Ini FileName for System Id',@S250),%dcIniFileName,REQ
          #DISPLAY ('(Use quotes, or a variable name)')
          #DISPLAY ('')
          #DISPLAY ('Language Table'),Prop(PROP:FontStyle,02000H) #!Underline
          #PROMPT  ('Language - File',FILE),%dcLanguageFile,REQ
          #PROMPT  ('Language - Primary Key',Key(%dcLanguageFile)),%dcLanguageKey,REQ
          #PROMPT  ('Language - System Id',Field(%dcLanguageFile)),%dcSysIdLanguage,REQ
          #PROMPT  ('Environment File Name',Field(%dcLanguageFile)),%dcEnvironmentFileName,REQ
       #ENDBOXED
    #ENDENABLE   
#ENDTAB
#TAB('Queue/In-Memory'),Where(%dcDisableTranslate = %False)
    #DISPLAY ('')
    #BOXED('In-Memory Tables'),Section
       #DISPLAY ('')
       #DISPLAY ('Clarion''s In-Memory-Driver is thread safe and Global')
       #DISPLAY ('Queues are not thread safe. If you don''t own the IMD')
       #DISPLAY ('driver then don''t tick the next box and the Template')
       #DISPLAY ('will generate the necessary Global Queues for you.')
       #DISPLAY ('')
       #PROMPT  ('Use Clarion''s In-Memory-Driver',CHECK),%UseIMD,AT(10)
       #DISPLAY ('')
       #ENABLE(%UseIMD=%TRUE)
          #PROMPT  ('IMD Trans-File',FILE),%dcIMDTranslateFile,REQ
          #PROMPT  ('IMD Trans-Language Key',Key(%dcIMDTranslateFile)),%dcIMDTranslateKey,REQ
          #PROMPT  ('IMD Trans-Language SysId',Field(%dcIMDTranslateFile)),%dcIMDSysIdTranslate,REQ
          #PROMPT  ('IMD Trans-Search',Field(%dcIMDTranslateFile)),%dcIMDSearchString,REQ
          #PROMPT  ('IMD Trans-Replace',Field(%dcIMDTranslateFile)),%dcIMDReplaceString,REQ          
       #ENDENABLE
    #ENDBOXED           
#ENDTAB
#ENDSHEET

#!------------------------------------------------------------------------------------------------------------------------
#AT(%GlobalData)
 #IF(%dcDisableAll=%False)
 #IF(%dcDisableTranslate=%False)
    #CASE(%ProgramExtension)
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    #OF('DLL')
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       #!------------------------------------------------------- 
       #IF(%GlobalExternal)           #!DLL but Not Data-Dict
       #!-------------------------------------------------------
          #IF(%UseIMD=%TRUE)          #!Use In-Memory Driver
          #!________________
dcGLO:SysIdLanguage      BYTE,EXTERNAL,DLL(_ABCDllMode_) !Language Flag       
          #!Do Nothing - IMD in Dictionary
          
          #ELSE                      #! Use Global Queue                  
          #!________________
dcGLO:SysIdLanguage      BYTE,EXTERNAL,DLL(_ABCDllMode_) !Language Flag
Language_Queue           QUEUE,PRE(dcLQ),EXTERNAL,DLL(_ABCDllMode_)
SysIdLanguage              Long
Search_Text                STRING(255)       !Added by dcTranslation1
Replace_Text               STRING(255)
                         END
                         
          #ENDIF   #!%UseIMD                  
       #!-------------------------------------------------------   
       #ELSE                          #!DLL and Data-Dict
       #!-------------------------------------------------------
          #IF(%UseIMD=%TRUE)          #!Use In-Memory Driver
          #!________________
dcGLO:SysIdLanguage      BYTE          !Language Flag       
             #!Do Nothing - IMD in Dictionary
             
          #ELSE                       #! Use Global Queue
          #!________________
dcGLO:SysIdLanguage      BYTE          !Language Flag
Language_Queue           QUEUE,PRE(dcLQ)
SysIdLanguage              Long              !Added by dcTranslation2
Search_Text                STRING(255)
Replace_Text               STRING(255)
                         END
                         
          #ENDIF   #!%UseIMD
       #ENDIF   #!%GlobalExternal
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
    #OF('EXE')
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       #IF(%dcSingleExe=%FALSE)     #!EXE AND Multi-Dll
       #!*~~~~~~~~~~~~~~~~~~~~~~~
          #IF(%UseIMD=%TRUE)          #!Use In-Memory Driver
          #!________________
dcGLO:SysIdLanguage  BYTE,EXTERNAL,DLL(_ABCDllMode_) !Language Flag          
             #!Do Nothing - IMD in Dictionary
             
          #ELSE                       #! Use Global Queue
          #!________________
dcGLO:SysIdLanguage  BYTE,EXTERNAL,DLL(_ABCDllMode_) !Language Flag
Language_Queue       QUEUE,PRE(dcLQ),EXTERNAL,DLL(_ABCDllMode_)
SysIdLanguage          Long               !Added by dcTranslation3
Search_Text            STRING(255)
Replace_Text           STRING(255)
                     END
                         
          #ENDIF   #!%UseIMD                  
       #ELSE                          #!EXE but Not Multi-Dll
       #!*~~~~~~~~~~~~~~~~~~~~~~~
          #IF(%UseIMD=%TRUE)          #!Use In-Memory Driver
          #!________________
dcGLO:SysIdLanguage  BYTE
           #!Do Nothing - IMD in Dictionary
           
          #ELSE                       #! Use Global Queue
          #!________________
dcGLO:SysIdLanguage  BYTE
Language_Queue       QUEUE,PRE(dcLQ)
SysIdLanguage          Long            !Added by dcTranslation4
Search_Text            STRING(255)
Replace_Text           STRING(255)
                     END
                         
          #ENDIF  #!%UseIMD                 
       #ENDIF  #!%dcSingleExe
    #ENDCASE
 #ENDIF  #!%dcDisableTranslate
 #ENDIF  #!%dcDisableAll
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%BeginningExports)
 #IF(%dcDisableAll=%False)
 #IF(%dcDisableTranslate=%False)
    #CASE(%ProgramExtension)
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    #OF('DLL')
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       #!------------------------------------------------------- 
       #IF(%GlobalExternal)           #!DLL but Not Data-Dict
       #!-------------------------------------------------------
    
          #!Don't do anything - not the data dll
       
       #!-------------------------------------------------------   
       #ELSE                          #!DLL and Data-Dict
       #!-------------------------------------------------------
          #IF(%UseIMD=%TRUE)          #!Use In-Memory Driver
          #!________________
$dcGLO:SysIdLanguage                                      @?
          #ELSE                       #! Use Global Queue
          #!________________
$dcGLO:SysIdLanguage                                      @?
$Language_Queue                                           @?       
          #ENDIF  #!%UseIMD
       #ENDIF   #!%GlobalExternal
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
    #OF('EXE')
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       #IF(%dcSingleExe=%FALSE)     #!EXE AND Multi-Dll
       #!*~~~~~~~~~~~~~~~~~~~~~~~
        
          #!Don't do anything - EXE but part of Multi-dll app
        
       #ELSE                        #!EXE but Not Multi-Dll
       #!*~~~~~~~~~~~~~~~~~~~~~~~
          #IF(%UseIMD=%TRUE)        #!Use In-Memory Driver
          #!________________       
$dcGLO:SysIdLanguage                                      @?          
          #ELSE                     #! Use Global Queue
          #!________________
$dcGLO:SysIdLanguage                                      @?
$Language_Queue                                           @?       
          #ENDIF  #!%UseIMD
       #ENDIF   #!%dcSingleExe
    #ENDCASE
 #ENDIF  #!%dcDisableTranslate
 #ENDIF  #!%dcDisableAll
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#AT(%ProgramSetup),PRIORITY(9000)
 #IF(%dcDisableAll=%False)
 #IF(%dcDisableTranslate=%False)
  #CASE(%ProgramExtension)
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    #OF('DLL')
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      #!------------------------------------------------------- 
      #IF(%GlobalExternal)            #!DLL but Not Data-Dict
      #!-------------------------------------------------------
         #IF(%UseIMD=%TRUE)           #!Use In-Memory Driver
         #!________________
 #Embed(%TranslationSetup,'Translation - Setup')       
 !Translation - Open In Memory  File
 Access:%dcIMDTranslateFile.Open()
 Access:%dcIMDTranslateFile.UseFile()      
 %dcIMDSysIdTranslate = dcGLO:SysIdLanguage       
 %dcIMDSearchString = ''
 Set(%dcIMDTranslateKey,%dcIMDTranslateKey)
 Loop Until Access:%dcIMDTranslateFile.Next()
    Translator.AddTranslation(Clip(%dcIMDSearchString),|
                              Clip(%dcIMDReplaceString))
 End       
 Access:%dcIMDTranslateFile.Close()
 #Embed(%TranslationFinish,'Translation - Finish')
         #ELSE                        #! Use Global Queue 
         #!________________
 #Embed(%TranslationSetup,'Translation - Setup')       
 Loop I# = 1 to Records(Language_Queue)
    Get(Language_Queue,I#)
    Translator.AddTranslation(Clip(dcLQ:Search_Text),|
                              Clip(dcLQ:Replace_Text))
 End   
 #Embed(%TranslationFinish,'Translation - Finish')
         #ENDIF   #!%UseIMD
      #!-------------------------------------------------------   
      #ELSE                           #!DLL and Data-Dict
      #!-------------------------------------------------------
         #INSERT  (%LOADLANGUAGE)
      #ENDIF   #!%GlobalExternal         
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    #OF('EXE')
    #!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 #Embed(%TranslationStart,'Start Translation')
       #IF(%dcSingleExe=%FALSE)     #!EXE AND Multi-Dll
       #!*~~~~~~~~~~~~~~~~~~~~~~~
 Access:%dcIMDTranslateFile.Open()
 Access:%dcIMDTranslateFile.UseFile()       
 %dcIMDSysIdTranslate = dcGLO:SysIdLanguage       
 %dcIMDSearchString = ''
 Set(%dcIMDTranslateKey,%dcIMDTranslateKey)
 Loop Until Access:%dcIMDTranslateFile.Next()
    Translator.AddTranslation(Clip(%dcIMDSearchString),|
                              Clip(%dcIMDReplaceString))
 End       
 Empty(%dcIMDTranslateFile)
 Access:%dcIMDTranslateFile.Close()
       #ELSE                          #!EXE but Not Multi-Dll
       #!*~~~~~~~~~~~~~~~~~~~~~~~
          #INSERT  (%LOADLANGUAGE)
       #ENDIF   #!%dcSingleExe
 #Embed(%TranslationFinish,'Finish Translation')
  #ENDCASE
 #ENDIF  #!%dcDisableTranslate
 #ENDIF  #!%dcDisableAll
#ENDAT
#!
#!
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!                                               PROCEDURE EXTENSION
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#EXTENSION(dcTranslatePictureProcedure,'Translation Pictures - Procedure')
!*****************************************************************************
#SHEET
#TAB('General')
    #Insert(%SETCC)
    #DISPLAY ('')
    #INSERT  (%SETPROC)
    #DISPLAY ('')
    #BOXED('Debugging'),section,AT(,65,,30)
      #Prompt('Disable All DinamiComp Templates',Check),%dcDisableAll,AT(10)
      #PROMPT  ('Disable DinamiComp''s Translation Templates',Check),%dcDisableTranslate,AT(10)
    #ENDBOXED
#ENDTAB
#TAB('Settings')
    #DISPLAY ('')
    #DISPLAY ('Change All Pictures to the Picture specified below')
    #DISPLAY ('')
    #PROMPT  ('Display Picture:',@S50),%dcPicture,REQ,DEFAULT('@N~R~-14.2')
#ENDTAB
#ENDSHEET

#!------------------------------------------------------------------------------------------------------------------------
#AT(%DataSection),PRIORITY(3000)
#IF(%dcDisableAll=%False)
 #IF(%dcDisableTranslate=%False)
#!Declare Queue to hold fieldnames and pictures
dcFieldQ    Queue,PRE()
DCQ:FieldID       String(50)
DCQ:FieldPicture  String(20)
          End

#!Declare Local variables
LOC:PictureString  CString(20)
LOC:New_Picture    Cstring(200)
LOC:Temp_Picture   Cstring(255)
LOC:dcCounter      Long
LOC:dcCounter1     Long
LOC:dcCounter2     Long
 #ENDIF  #!%dcDisableTranslate
#ENDIF  #!%dcDisableAll
#ENDAT


#!------------------------------------------------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(8000)
#IF(%dcDisableAll=%False)
 #IF(%dcDisableTranslate=%False)
 #! Populate the next variable based on your language requirements
 LOC:PictureString = '%dcPicture'

 Free(dcFieldQ)
     #FIX(%File,%Primary)
     #FOR(%Field)
       #IF(%FieldType='BLOB')
            #CYCLE
       #ENDIF
       #IF(%Fieldtype='GROUP')
          #CYCLE
       #ENDIF
       #IF(%Fieldtype='END')
          #CYCLE
       #ENDIF
       LOC:dcCounter = Instring('@N',Upper('%FieldPicture'),1,1)
       If LOC:dcCounter > 0
          If Instring('.2',Upper('%FieldPicture'),1,I#)
             DCQ:FieldID      = Upper('%FilePrefix:%FieldID')
             DCQ:FieldPicture = '%FieldPicture'
             Add(dcFieldQ)
          End
       End
     #ENDFOR

#FOR(%Secondary)
     #FIX(%File,%Secondary)
     #FOR(%Field)
       #IF(%FieldType='BLOB')
            #CYCLE
       #ENDIF
       #IF(%Fieldtype='GROUP')
          #CYCLE
       #ENDIF
       #IF(%Fieldtype='END')
          #CYCLE
       #ENDIF
       LOC:dcCounter = Instring('@N',Upper('%FieldPicture'),1,1)
       If LOC:dcCounter > 0
          If Instring('.2',Upper('%FieldPicture'),1,I#)
             DCQ:FieldID      = Upper('%FilePrefix:%FieldID')
             DCQ:FieldPicture = '%FieldPicture'
             Add(dcFieldQ)
          End
       End
     #ENDFOR
#ENDFOR

#FOR(%OtherFiles)                      #! Open Other files
    #FIX(%File,%OtherFiles)
    #FOR(%Field)
       #IF(%FieldType='BLOB')
         #CYCLE
       #ENDIF
       #IF(%FieldType='MEMO')
         #CYCLE
       #ENDIF
       #IF(%Fieldtype='GROUP')
         #CYCLE
       #ENDIF
       #IF(%Fieldtype='END')
         #CYCLE
       #ENDIF
       LOC:dcCounter = Instring('@N',Upper('%FieldPicture'),1,1)
       If LOC:dcCounter > 0
          If Instring('.2',Upper('%FieldPicture'),1,I#)
             DCQ:FieldID      = Upper('%FilePrefix:%FieldID')
             DCQ:FieldPicture = '%FieldPicture'
             Add(dcFieldQ)
          End
       End
    #ENDFOR
#ENDFOR


 #! Run through controls on the window and change the picture where necessary
 #FOR(%Control)
     #IF(%ControlType='ENTRY')
        #If(%ControlUse <> '')
           DCQ:FieldID = Upper('%ControlUse')
           Get(DCFieldQ,DCQ:FieldID)
           If not error()
              ?%ControlUse{Prop:Text} = LOC:PictureString
           End
        #ENDIF
     #ELSIF(%ControlType='LIST')
        #!Remember that a picture in a list starts with "@" and ends with "@" for example: @n~$~-10.2@

        LOC:DCCounter = 1
        !Check picture strings through a loop because the picture from more than one column might need to be changed

        Loop
           !First find the "@N"
           LOC:dcCounter = Instring('@N',Upper(%Control{Prop:Format}),1,LOC:dcCounter)

           !Find the end of the picture string by finding the next "@"
           LOC:dcCounter1 = Instring('@',Upper(%Control{Prop:Format}),1,LOC:dcCounter+1)

           !See if picture string ends in ".2@"
           LOC:dcCounter2 = Instring('.2@',Upper(%Control{Prop:Format}),1,LOC:dcCounter+1)

           !if the ending "@" and the ".2@" are part of the same picture string then change the picture
           If LOC:dcCounter1 = LOC:dcCounter2+2
              LOC:Temp_Picture = Sub(%Control{Prop:Format},1,LOC:dcCounter-1) & Clip(LOC:PictureString) & '@' & |
                                 Sub(%Control{Prop:Format},LOC:dcCounter2+3,Len(%Control{Prop:Format}))
              %Control{Prop:format} = LOC:Temp_Picture
           End

           !If no more "@N" or ".2@" left in the format string then break out of the loop
           If LOC:dcCounter = 0 or LOC:dcCounter2 = 0 then break.

           !If found a ".2@" but it is further into the format string - increase LOC:dcCounter counter and continue search
           If LOC:dcCounter2 > LOC:dcCounter1
              LOC:dcCounter = LOC:dcCounter1 + 1
              Cycle
           End
           LOC:dcCounter += 1
        End
     #ENDIF
 #ENDFOR
 #ENDIF  #!%dcDisableTranslate
 #ENDIF  #!%dcDisableAll
#ENDAT

#!---------------------------------------------------------------------------------------------------
#GROUP(%SETCC)
  #IMAGE ('Dinamicomp.bmp'),at(5)
  #BOXED (''),Section,AT(80,15,110,70)
     #DISPLAY ('DinamiComp''s Translation'),prop(PROP:FontStyle,700),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('Version 1.02'),prop(PROP:FontStyle,700),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('Copyright  2005 by'),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('DinamiComp Network &&'),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('Computer Consultants CC'),prop(PROP:FontName,%AppTPLFontName)
     #DISPLAY ('www.dinamicomp.co.za'),prop(PROP:FontName,%AppTPLFontName)
  #ENDBOXED

#!---------------------------------------------------------------------------------------------------
#GROUP(%SETAPP)
#BOXED('DinamiComp Translation Templates'),SECTION,AT(,10,,30)
  #DISPLAY ('Load all Information required to execute')
  #DISPLAY ('runtime Translation in your Application.')
#ENDBOXED

#!---------------------------------------------------------------------------------------------------
#GROUP(%SETPROC)
#BOXED('DinamiComp International Templates'),SECTION,AT(,10,,55)
  #DISPLAY ('Change Currency Picture on a Window or form')
  #DISPLAY ('Currency Picture is hard coded in template')
#ENDBOXED

#!---------------------------------------------------------------------------------------------------
#GROUP(%LOADLANGUAGE)

         #IF(%UseIMD=%TRUE)           #!Use In-Memory Driver
         #!________________
 #!##############################################################################################         
 #Embed(%TranslationSetup,'Translation - Setup')
 !Translation
           #IF(%dcUseLanguageFile=%TRUE)
 INIMgr.Init(%dcIniFileName)
 dcGLO:SysIdLanguage = INIMgr.Fetch('Preferences','Language')
 If dcGLO:SysIdLanguage = 0
    dcGLO:SysIdLanguage = 1
    INIMgr.Update('Preferences','Language',dcGLO:SysIdLanguage)
 Else    
 End     
 !Get Language - EnvironmentFileName
 Access:%dcLanguageFile.Open()
 Access:%dcLanguageFile.UseFile()
              #IF(%dcUseSQLFiles=%False)
              #!*~~~~~~~~~~~~~~~~~~~~~~~~~~
              #!Use Non SQL File
 %dcSysIdLanguage = dcGLO:SysIdLanguage
 If Access:%dcLanguageFile.TryFetch(%dcLanguageKey) = Level:Benign and |
    Clip(%dcEnvironmentFileName) <> ''
    !Set Language Environment FileName
    LOCALE(Clip(%dcEnvironmentFileName))
 Else    
    Message('Problem with Language File for LanguageID = ' & dcGLO:SysIdLanguage & ' and Error Code = ' & ERRORCODE())
 End     
              #ELSE
              #!*~~~~~~~~~~~~~~~~~~~~~~~~~~
              #!Use SQL File  
 #FIND(%Field,%dcSysIdLanguage) 
 Set(%dcLanguageFile)
 Send(%dcLanguageFile,'/where "%FieldID" = ' & dcGLO:SysIdLanguage)
 Next(%dcLanguageFile)
 If Not error() and Clip(%dcEnvironmentFileName) <> ''
    !Set Language Environment FileName
    LOCALE(Clip(%dcEnvironmentFileName))
 Else    
    Message('Problem with Language File for LanguageID = ' & dcGLO:SysIdLanguage & ' and Error Code = ' & ERRORCODE())
 End         
              #ENDIF   #!%dcUseSQLFiles
           #ENDIF   #!%dcUseLanguageFile
 #Embed(%TranslationStrings,'Translation - Add Translation Strings')
 #!Add translation strings to Queue
 !Open Translate File
 Access:%dcTranslateFile.Open()
 Access:%dcTranslateFile.UseFile()
 !Open In Memory File
 Access:%dcIMDTranslateFile.Open()
 Access:%dcIMDTranslateFile.UseFile()
 Empty(%dcIMDTranslateFile)
 %dcSysIdTranslate = dcGLO:SysIdLanguage
 %dcSearchString = ''
 Set(%dcTranslateKey,%dcTranslateKey)
 Loop Until Access:%dcTranslateFile.Next()
    If %dcSysIdTranslate <> dcGLO:SysIdLanguage then Break.
    Translator.AddTranslation(Clip(%dcSearchString), Clip(%dcReplaceString))
    %dcIMDSearchString  = Clip(%dcSearchString)
    %dcIMDReplaceString = Clip(%dcReplaceString)
    %dcIMDSysIdTranslate  = %dcSysIdLanguage
    !Add to Queue
    If Access:%dcIMDTranslateFile.TryInsert() <> Level:Benign
       Stop(error())
    Else
    End
 End  !Loop
 Access:%dcTranslateFile.Close()
 Access:%dcLanguageFile.Close()           
 Access:%dcIMDTranslateFile.Close()
 #Embed(%TranslationFinish,'Translation - Finish')
         #ELSE                        #!Use Global Queue        
         #!________________
 #!##############################################################################################         
 #Embed(%TranslationStart,'Translation - Setup')       
 !Translation
 INIMgr.Init('SaleSSet.Ini')
 dcGLO:SysIdLanguage = INIMgr.Fetch('Preferences','Language')
 If dcGLO:SysIdLanguage = 0
    dcGLO:SysIdLanguage = 1
    INIMgr.Update('Preferences','Language',dcGLO:SysIdLanguage)
 Else
 End
 !Get Language - EnvironmentFileName
 Access:%dcLanguageFile.Open()
 Access:%dcLanguageFile.UseFile()
 %dcSysIdLanguage = dcGLO:SysIdLanguage
 If Access:%dcLanguageFile.TryFetch(%dcLanguageKey) = Level:Benign and |
    Clip(%dcEnvironmentFileName) <> ''
    LOCALE(Clip(%dcEnvironmentFileName))
 Else
    Message('Problem with Language File for LanguageID = ' & dcGLO:SysIdLanguage & ' and Error Code = ' & ERRORCODE())
 End
 #Embed(%TranslationStrings,'Translation - Add Translation Strings')
 !Add translation strings to Queue
  Access:%dcTranslateFile.Open()
 Access:%dcTranslateFile.UseFile()
 Free(Language_Queue)
 %dcSysIdTranslate = dcGLO:SysIdLanguage
 Set(%dcTranslateKey,%dcTranslateKey)
 Loop Until Access:%dcTranslateFile.Next()
    If %dcSysIdTranslate <> dcGLO:SysIdLanguage then Break.
    Translator.AddTranslation(Clip(%dcSearchString), Clip(%dcReplaceString))
    dcLQ:Search_Text   = Clip(%dcSearchString)
    dcLQ:Replace_Text  = Clip(%dcReplaceString)
    dcLQ:SysIdLanguage = %dcSysIdLanguage
    !Add to Queue
    Add(Language_Queue)
    If error() then stop(error()).
 End  !Loop
 Access:%dcTranslateFile.Close()
 Access:%dcLanguageFile.Close()  
 #Embed(%TranslationFinish,'Translation - Finish')
         #ENDIF   #!%UseIMD
      